<?php
namespace ByDedi\AdminBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Sonata\UserBundle\Entity\BaseUser;

/**
 * Class User
 *
 * @ORM\Table(name="admin_user")
 * @ORM\Entity()
 */
class User extends BaseUser
{

    /**
     * @var integer $id
     *
     * @ORM\Id()
     * @ORM\GeneratedValue(strategy="AUTO")
     * @ORM\Column(type="integer")
     */
    protected $id;


    /**
     * @ORM\ManyToMany(targetEntity="ByDedi\AdminBundle\Entity\Group")
     * @ORM\JoinTable(name="admin_user_group",
     *      joinColumns={@ORM\JoinColumn(name="user_id", referencedColumnName="id")},
     *      inverseJoinColumns={@ORM\JoinColumn(name="group_id", referencedColumnName="id")}
     * )
     */
    protected $groups;

    public function __construct()
    {
        parent::__construct();
    }

    public function getRoles()
    {
        $roles = parent::getRoles();
        foreach ($roles as $k => $v) {
            $hierarchyRoles = explode(':', $v);
            if (!empty($hierarchyRoles[1])) {
                $otherRoles = explode(',', $hierarchyRoles[1]);
                foreach ($otherRoles as $otherRole) {
                    if (!in_array(trim($otherRole), $roles)) {
                        $roles[] = trim($otherRole);
                    }
                }
                if (!in_array($hierarchyRoles[0], $roles)) {
                    $roles[] = $hierarchyRoles[0];
                }
                unset($roles[$k]);
            }
        }
        $roles = array_unique(array_values($roles));

        return $roles;
    }
}
